/*
  Scrivere un programma che dato un vettore A di n interi stabilisca 
  se A contiene o meno un elemento (detto maggioritario) tale che occorra almeno 
  n/2+1 volte.
  La prima fase del programma deve prevedere la lettura da tastiera della dimensione 
  n (> 0) e degli elementi di A. Si assuma che ciascun intero inserito da tastiera sia seguito da '\n'.
  Il programma dunque scrive a video Si x\n dove x è l'elemento maggioritario o 
  No\n nel caso in cui un tale elemento non sia presente in A.

  !!!! Rispettare le specifiche per quanto riguarda input e output. 
  Ad esempio, si eviti di stampare a video frasi del tipo "Inserire n:", 
  "L'elemento maggioritario è:" ecc.
*/

#include <stdlib.h>
#include <stdio.h>

/* La funzione scandisce a e controlla se value sia maggioritario o meno. 
   Restituisce 1 in caso di esito positivo o 0 altrimenti */
 
int controlla(int a[], int n, int candidate) {

  int i, occ = 0;

  for ( i = 0; i < n; i++ ) 
	if ( a[i] == candidate) occ++;

  if( occ >= n/2+1 ) return 1;
  else return 0;

}

/* La funzione risolve il problema della majority sul vettore a utilizzando un algoritmo 
   quatratico nella dimensione dell'input. Se l'elemento maggioritario viene individuato 
   questo è memorizzato nella cella puntata da mj e restituisce 1, altrimenti la funzione 
   restituisce 0 */ 

int majority(int a[], int n, int *mj) {
  
  int i;
  
  for ( i = 0; i < n; i++ ) 
    if ( controlla(a, n, a[i]) ) {
		 *mj = a[i]; 
		 return 1;
	}

   return 0;
}

int main() { 

  int n, *A, mj, i;

  scanf("%d", &n);
  if(n <= 0) return 1;

  A = (int *) malloc(n * sizeof(int));
  if(A == NULL) return 1;

  for( i = 0; i < n; i++ ) 
	  scanf("%d", A+i);
  
  if( majority(A, n, &mj) ) printf("Si %d\n", mj);
  else printf("No\n");

  return 0;

}